diff --git a/src/column_system.c b/src/column_system.c
index 69fc2f986..f16abb81e 100644
--- a/src/column_system.c
+++ b/src/column_system.c
@@ -1117,13 +1117,21 @@ ecs_entity_t _ecs_run_w_filter(
     ecs_type_t include_type,
     void *param)
 {
-    ecs_filter_t filter = {
-        .include = include_type,
-        .include_kind = EcsMatchAll
-    };
+    ecs_entity_t interrupted_by = 0;
+
+    if (include_type) {
+        ecs_filter_t filter = {
+            .include = include_type,
+            .include_kind = EcsMatchAll
+        };
 
-    ecs_entity_t interrupted_by = ecs_run_w_filter_v2(
-        world, system, delta_time, offset, limit, &filter, param);
+        interrupted_by = ecs_run_w_filter_v2(
+            world, system, delta_time, offset, limit, &filter, param);
+    } else {
+        interrupted_by = ecs_run_w_filter_v2(
+            world, system, delta_time, offset, limit, NULL, param);
+
+    }
 
     return interrupted_by;
 }
diff --git a/test/api/project.json b/test/api/project.json
index 6945fe730..21b135799 100644
--- a/test/api/project.json
+++ b/test/api/project.json
@@ -346,7 +346,9 @@
                 "dont_enable_after_rematch",
                 "ensure_single_merge",
                 "table_count",
-                "active_system_count"
+                "active_system_count",
+                "match_system",
+                "match_system_w_filter"
             ]
         }, {
             "id": "SystemOnAdd",
diff --git a/test/api/src/SystemMisc.c b/test/api/src/SystemMisc.c
index e5a46c5c6..41f44db58 100644
--- a/test/api/src/SystemMisc.c
+++ b/test/api/src/SystemMisc.c
@@ -795,10 +795,12 @@ static void SysA(ecs_rows_t *rows)
 }
 
 static int b_invoked;
+static ecs_entity_t b_entity;
 
 static void SysB(ecs_rows_t *rows)
 {
     b_invoked ++;
+    b_entity = rows->entities[0];
 }
 
 void SystemMisc_ensure_single_merge() {
@@ -878,3 +880,37 @@ void SystemMisc_active_system_count() {
     
     ecs_fini(world);
 }
+
+void SystemMisc_match_system() {
+    ecs_world_t *world = ecs_init();
+
+    ECS_COMPONENT(world, Position);
+    ECS_COMPONENT(world, Velocity);
+
+    ECS_SYSTEM(world, SysA, EcsManual, SYSTEM.Position);
+    ECS_SYSTEM(world, SysB, EcsManual, Position);
+
+    ecs_run(world, SysB, 0, NULL);
+
+    test_assert(b_invoked != 0);
+    test_assert(b_entity == SysA);
+    
+    ecs_fini(world);
+}
+
+void SystemMisc_match_system_w_filter() {
+    ecs_world_t *world = ecs_init();
+
+    ECS_COMPONENT(world, Position);
+    ECS_COMPONENT(world, Velocity);
+
+    ECS_SYSTEM(world, SysA, EcsManual, SYSTEM.Position);
+    ECS_SYSTEM(world, SysB, EcsManual, Position);
+
+    ecs_run_w_filter(world, SysB, 0, 0, 0, Position, NULL);
+
+    test_assert(b_invoked != 0);
+    test_assert(b_entity == SysA);
+    
+    ecs_fini(world);
+}
diff --git a/test/api/src/main.c b/test/api/src/main.c
index 3468dfde5..6cdd1a77d 100644
--- a/test/api/src/main.c
+++ b/test/api/src/main.c
@@ -312,6 +312,8 @@ void SystemMisc_dont_enable_after_rematch(void);
 void SystemMisc_ensure_single_merge(void);
 void SystemMisc_table_count(void);
 void SystemMisc_active_system_count(void);
+void SystemMisc_match_system(void);
+void SystemMisc_match_system_w_filter(void);
 
 // Testsuite 'SystemOnAdd'
 void SystemOnAdd_new_match_1_of_1(void);
@@ -1938,7 +1940,7 @@ static bake_test_suite suites[] = {
     },
     {
         .id = "SystemMisc",
-        .testcase_count = 44,
+        .testcase_count = 46,
         .testcases = (bake_test_case[]){
             {
                 .id = "invalid_not_without_id",
@@ -2115,6 +2117,14 @@ static bake_test_suite suites[] = {
             {
                 .id = "active_system_count",
                 .function = SystemMisc_active_system_count
+            },
+            {
+                .id = "match_system",
+                .function = SystemMisc_match_system
+            },
+            {
+                .id = "match_system_w_filter",
+                .function = SystemMisc_match_system_w_filter
             }
         }
     },
